<?php

declare(strict_types=1);

namespace Rector\TypeDeclaration\ValueObject;

use PHPStan\Type\MixedType;
use PHPStan\Type\Type;

final class NestedArrayType
{
    public function __construct(
        private readonly Type $type,
        private readonly int $arrayNestingLevel,
        private readonly ?Type $keyType = null
    ) {
    }

    public function getType(): Type
    {
        return $this->type;
    }

    public function getArrayNestingLevel(): int
    {
        return $this->arrayNestingLevel;
    }

    public function getKeyType(): Type
    {
        if ($this->keyType instanceof Type) {
            return $this->keyType;
        }

        return new MixedType();
    }
}
